/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://bitbucket.org/tidalwave/openbluesky-src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.platformx.inject.api;

import javax.annotation.Nonnull;
import java.util.Collection;
import org.openide.util.Lookup;

/**
 *
 * @author fritz
 */
public abstract class Injector
  {
    @Nonnull
    public static Injector getDefault()
      {
        final Lookup lookup = Lookup.getDefault();
        final Injector injector = lookup.lookup(Injector.class);

        if (injector == null)
          {
            throw new RuntimeException("Can't find an Injector");
          }

        return injector;
      }
    
    public abstract void inject (final @Nonnull Object object,
                                 final @Nonnull Lookup lookup);

    public abstract void inject (final @Nonnull Collection<Object> objects,
                                 final @Nonnull Lookup lookup);
  }
